#include  <stdio.h>
#include  <ctype.h>
#include   "sac.h"

set_hd0_(shd, hd_name, hd_buf, nerr)
struct   SACHD *shd;
char     *hd_name;              /* head variable name       */
void     *hd_buf;               /* head variable buffer     */
int      *nerr;
{
   int      nc, hdn,  nlen;
   int      nwt;
   int      find;

   find = OFF;
   *nerr = 0;
   nlen = strlen(hd_name);
   for(nc = 0; nc < nlen; nc++ )
      hd_name[nc] = tolower(hd_name[nc]);
   for(nc = 0; nc < HDMAX; nc++)
   {
      if(!charcmp(hd_name, sacindx[nc].hdnm))
      {  
         find  = ON;
         hdn = sacindx[nc].hdn - 1;
         switch(sacindx[nc].type)   {
            case     FLOAT :
                            nwt   = 4;
                            memcpy(&shd->r_hd[hdn], hd_buf,  nwt);
                            break;
            case     INTE4 :
                            nwt   = 4;
                            memcpy(&shd->n_hd[hdn], hd_buf,  nwt);
                            break;
            case     CHAR8 :
                            nwt   = 8;
                            memcpy(shd->a_hd[hdn], hd_buf,  nwt);
                            shd->a_hd[hdn][7] = '\0';
                            break;
            case     CHAR16 :
                            nwt   = 16;
                            memcpy(shd->a_hd[hdn], hd_buf,  nwt);
                            if(shd->a_hd[hdn][7] == '\0') shd->a_hd[hdn][7] = ' ';
                            shd->a_hd[hdn][15] = '\0';
                            break;
            default         :
                            break;
         }                   
         break;
      }
   }
   if(find == OFF)
   {
      fprintf(stderr, "%s IS NOT A CORRECT HEAD VARIABLE NAME  !!\n",
              hd_name);
      *nerr = -1;
   }
}
set_hd_(sac_fil, hd_name, hd_buf, nerr)
char     *sac_fil;              /* sac file name            */
char     *hd_name;              /* head variable name       */
void     *hd_buf;               /* head variable buffer     */
int      *nerr;
{
   FILE       *fpin;
   struct   SACHD    shd;
   int      nc, hdn,  nlen;
   int      nseek, nwt;
   int      find;
 
   find = OFF;
   *nerr = 0;
   nlen = strlen(hd_name);
   for(nc = 0; nc < nlen; nc++ )
      hd_name[nc] = tolower(hd_name[nc]);
   if((fpin = fopen(sac_fil, "r+b")) == NULL)
   {
      fprintf(stderr,  "%s  FILE OPEN ERROR\n", sac_fil);
      exit();
   }
   for(nc = 0; nc < HDMAX; nc++)
   {
      if(!charcmp(hd_name, sacindx[nc].hdnm))
      {  
         find  = ON;
         hdn = sacindx[nc].hdn - 1;
         switch(sacindx[nc].type)   {
            case     FLOAT :
                            nseek = hdn * 4;
                            nwt   = 4;
                            memcpy(&shd.r_hd[hdn], hd_buf,  nwt);
                            fseek(fpin, nseek, 0);
                            fwrite(&shd.r_hd[hdn], nwt, 1, fpin);
                            break;
            case     INTE4 :
                            nseek = HD_FLOAT_LEN * 4 + hdn * 4;
                            nwt   = 4;
                            memcpy(&shd.n_hd[hdn], hd_buf,  nwt);
                            fseek(fpin, nseek, 0);
                            fwrite(&shd.n_hd[hdn], nwt, 1, fpin);
                            break;
            case     CHAR8 :
                            nseek = HD_FLOAT_LEN * 4 +
                                    HD_INTE4_LEN * 4 + hdn * 8;
                            nwt   = 8;  
                            memcpy(shd.a_hd[hdn], hd_buf,  nwt);
                            shd.a_hd[hdn][7] = '\0';
                            fseek(fpin, nseek, 0);
                            fwrite(shd.a_hd[hdn], nwt, 1, fpin);
                            break;
            case     CHAR16 :
                            nseek = HD_FLOAT_LEN * 4 +
                                    HD_INTE4_LEN * 4 + hdn * 8;
                            nwt   = 16;
                            memcpy(shd.a_hd[hdn], hd_buf,  nwt);
                            if(shd.a_hd[hdn][7] == '\0') shd.a_hd[hdn][7] = ' ';
                            shd.a_hd[hdn][15] = '\0';
                            fseek(fpin, nseek, 0);
                            fwrite(shd.a_hd[hdn], nwt, 1, fpin); 
                            break;
            default         :
                            break;
         }                   
         break;
      }
   }
   fclose(fpin);
   if(find == OFF)
   {
      fprintf(stderr, "%s IS NOT A CORRECT HEAD VARIABLE NAME  !!\n",
              hd_name);
      *nerr = -1;
   }
}
init_hd_(shd)
struct   SACHD *shd;
{
   int  nc;

   for(nc=0; nc < HD_FLOAT_LEN; nc++)       /* initialize  real part         */
      shd->r_hd[nc] = DEFAULT_FLOAT;
   for(nc = 0; nc < HD_INTE4_LEN; nc++)     /* initialize   integer part     */
      shd->n_hd[nc] = DEFAULT_INTE4;
   for(nc = 0; nc < HD_CHAR_LEN; nc++)      /* initialize   character part   */
      strncpy(shd->a_hd[nc], DEFAULT_CHAR, 8);
      
   shd->n_hd[6] = 6;                        /* Header version                */
   shd->n_hd[7] = 0;                        /* internal variable             */
   shd->n_hd[8] = 0;                        /* internal variable             */
   shd->n_hd[15] = 1 ;                      /* Type of  file                 */
   shd->n_hd[35] = 1 ;                      /* evenly spaced flag            */
   shd->n_hd[36] = 0 ;                      /* positive polarity flag        */
   shd->n_hd[37] = 1 ;                      /* write flag                    */
   shd->n_hd[38] = 1 ;                      /*                               */
   shd->n_hd[39] = 0 ;                      /* internal variable             */
}




wt_sac1(sac_fil, vl, nv, beg, delta)
char    *sac_fil;                           /* sac file name                 */
float   *vl;                                /* variable                      */
int     nv;                                 /* length of variable            */
float   beg;                                /* begin time                    */
float   delta;                              /* sampling interval             */
{
   struct   SACHD shd;
   FILE           *fpsac;
   int      npts, nerr; 
   float   rb0, deltt, vlmin, vlmax, vlmen;
   

   init_hd_(&shd);
   if((fpsac = fopen(sac_fil, "w")) == NULL)
   {
      fprintf(stderr,  "%s  FILE OPEN ERROR\n", sac_fil);
      exit();
   } 
   
   fwrite(&shd, sizeof(shd), 1, fpsac);
   fwrite(vl, 4, nv, fpsac);
   fclose(fpsac);
   maxmin_(vl, nv, &vlmin, &vlmax, &vlmen); /*  maxmin & minimum of array    */
   rb0 = beg;                               /* set bigin time                */
   deltt = delta;                           /* set interval time             */
   npts = nv;
   set_hd_(sac_fil, "b", &rb0, &nerr);      /* write begin time to file      */
   set_hd_(sac_fil, "delta", &deltt, &nerr);/* write sampl. interval to file */
   set_hd_(sac_fil, "npts", &npts, &nerr);  /* write sampling points to file */
   set_hd_(sac_fil, "depmin", &vlmin, &nerr);
   set_hd_(sac_fil, "depmax", &vlmax, &nerr);
   set_hd_(sac_fil, "depmen", &vlmen, &nerr);
   set_hd_(sac_fil, "kstnm", "", &nerr);
   set_hd_(sac_fil, "kevnm", "", &nerr);
   set_hd_(sac_fil, "kcmpnm", "", &nerr); 
}
   
wt_sac2(sac_fil, shd, vl)
char    *sac_fil;                           /* sac file name                 */
float   *vl;                                /* variable                      */
struct  SACHD *shd;
{
   FILE           *fpsac;
   int            nv;

   
   if((fpsac = fopen(sac_fil, "w")) == NULL)
   {
      fprintf(stderr,  "%s  FILE OPEN ERROR\n", sac_fil);
      exit();
   }
   nv = shd->n_hd[9];
   fwrite(shd, sizeof(struct SACHD), 1, fpsac);
   fwrite(vl, 4, nv, fpsac);
   fclose(fpsac);
}
wt_sac_cont_(sac_fil, nx, xmin, xmax, ny, ymin, ymax, vl)
char    *sac_fil;                           /* sac file name                 */
int     nx, ny;
float   xmin, xmax, ymin, ymax;
float   *vl;                                /* variable                      */
{
   FILE           *fpsac;
   struct  SACHD shd;
   int            nc;
 
 
   if((fpsac = fopen(sac_fil, "w")) == NULL)
   {
      fprintf(stderr,  "%s  FILE OPEN ERROR\n", sac_fil);
      exit();
   }
   for(nc=0; nc < HD_FLOAT_LEN; nc++)       /* initialize  real part         */
      shd.r_hd[nc] = DEFAULT_FLOAT;
   for(nc = 0; nc < HD_INTE4_LEN; nc++)     /* initialize   integer part     */
      shd.n_hd[nc] = DEFAULT_INTE4;
   for(nc = 0; nc < HD_CHAR_LEN; nc++)      /* initialize   character part   */
      strcpy(shd.a_hd[nc], DEFAULT_CHAR);
   shd.n_hd[6] = 6;                        /* Header version                */
   shd.n_hd[7] = 0;                        /* internal variable             */
   shd.n_hd[8] = 0;                        /* internal variable             */
   shd.n_hd[15] = 51 ;                     /* Type of  file                 */
   shd.n_hd[35] = 1 ;                      /* evenly spaced flag            */
   shd.n_hd[36] = 0 ;                      /* positive polarity flag        */
   shd.n_hd[37] = 1 ;                      /* write flag                    */
   shd.n_hd[38] = 1 ;                      /*                               */
   shd.n_hd[39] = 0 ;                      /* internal variable             */
   shd.r_hd[0] = 1.; shd.r_hd[5] = 0.;
   shd.r_hd[6] = shd.r_hd[5] + (nx * ny - 1) * shd.r_hd[0];
   shd.r_hd[59] = xmin; shd.r_hd[60] = xmax;
   shd.r_hd[61] = ymin; shd.r_hd[62] = ymax;
   shd.n_hd[9] = nx * ny;
   shd.n_hd[12] = nx ;
   shd.n_hd[13] = ny ;
   fwrite(&shd, sizeof(struct SACHD), 1, fpsac);
   fwrite(vl, 4, nx*ny, fpsac);
   fclose(fpsac);
}

wt_sacF_(sac_fil, r_hd, n_hd, a_hd, vl)
char    *sac_fil;                           /* sac file name                 */  
float   *vl;                                /* variable                      */
float   *r_hd;
int     *n_hd;
char    a_hd[HD_CHAR_LEN][8];
{
   FILE           *fpsac;
   int            nv;


   if((fpsac = fopen(sac_fil, "w")) == NULL)
   {
      fprintf(stderr,  "%s  FILE OPEN ERROR\n", sac_fil);
      exit();
   }
   nv = n_hd[9];
   fwrite(r_hd, 4, HD_FLOAT_LEN, fpsac);
   fwrite(n_hd, 4, HD_INTE4_LEN, fpsac);
   fwrite(a_hd, 8*HD_CHAR_LEN, 1, fpsac);
   fwrite(vl, 4, nv, fpsac);
   fclose(fpsac);
}
wt_sac1F_(sac_fil, vl, nv0, beg0, delta0)
char    *sac_fil;                           /* sac file name                 */
float   *vl;                                /* variable                      */
int     *nv0;                                 /* length of variable            */
float   *beg0;                                /* begin time                    */
float   *delta0;                              /* sampling interval             */
{
   struct   SACHD shd;
   FILE           *fpsac;
   int      npts, nerr;
   float   rb0, deltt, vlmin, vlmax, vlmen;
	int	nv;
	float	beg, delta;


	nv = *nv0; beg = *beg0; delta = *delta0;
   init_hd_(&shd);
   if((fpsac = fopen(sac_fil, "w")) == NULL)
   {
      fprintf(stderr,  "%s  FILE OPEN ERROR\n", sac_fil);
      exit();
   }

   fwrite(&shd, sizeof(shd), 1, fpsac);
   fwrite(vl, 4, nv, fpsac);
   fclose(fpsac);
   maxmin_(vl, nv, &vlmin, &vlmax, &vlmen); /*  maxmin & minimum of array    */
   rb0 = beg;                               /* set bigin time                */
   deltt = delta;                           /* set interval time             */
   npts = nv;
   set_hd_(sac_fil, "b", &rb0, &nerr);      /* write begin time to file      */
   set_hd_(sac_fil, "delta", &deltt, &nerr);/* write sampl. interval to file */
   set_hd_(sac_fil, "npts", &npts, &nerr);  /* write sampling points to file */
   set_hd_(sac_fil, "depmin", &vlmin, &nerr);
   set_hd_(sac_fil, "depmax", &vlmax, &nerr);
   set_hd_(sac_fil, "depmen", &vlmen, &nerr);
   set_hd_(sac_fil, "kstnm", "", &nerr);
   set_hd_(sac_fil, "kevnm", "", &nerr);
   set_hd_(sac_fil, "kcmpnm", "", &nerr);
}

